/*****************************************************
Project   :    
Version   : 1.2
Date      : 19.01.2013
Begin date: 09.01.2013
Author    : FishKa

Chip type               : ATtiny45
AVR Core Clock frequency: 6,400000 MHz  int
Fuse bits               : 0x53 0xDF 0xFF
*****************************************************/
#include <tiny45.h>
#include <stdlib.h>
#include <delay.h>

int clk = 0;
              // 12  Proteus'a
const int skipclk = 100;     //        (takt)
const int zoneone = 25000;//18000;   //   0/1
//int numseg =  5;       //     + 1 
const int numled =  8;       //    
const int maxled = 56; //    
int takt   =  0;       //   
int pause  = maxled;
int delta  = -1;
int cikl   = 0;        //   
const int ciklChange = 16;
#define step 4;
const int mindelay=5;
int delay;
//
char X;
//

void mkCLOCK()
{
  //      CLOCK -> PORTB.0 
  delay_ms(1);
  PORTB.0= 1;
  delay_ms(1);
  PORTB.0= 0; //  CLOCK  0
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
  TCNT0=0xFF; // Reinitialize Timer 0 value
return;
  if (clk++ > skipclk)
   { //  
     clk = 0;
                                              
     if ((takt<numled) && (rand() > zoneone)) PORTB.1= 1;
     else PORTB.1= 0; 

     if (takt++ > pause) { takt = 0; cikl++; }
        
     if (cikl == ciklChange)
      {    
        cikl  = 0;    
        pause = pause + delta;
        if (pause == 0) delta = step;
        else
        if (pause==maxled) delta= -step;
      }
     //      CLOCK -> PORTB.0
     mkCLOCK(); 
   }
}

void shiftAll()
{
  int i;
  for(i=0; i<maxled; i++)
     //      CLOCK -> PORTB.0
     mkCLOCK(); 
}

void main(void)
{
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State5=P State4=P State3=P State2=P State1=0 State0=0 
PORTB=0x3C;
DDRB=0x03;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFF
// OC0A output: Toggle on compare match
// OC0B output: Disconnected
//TCCR0A=0x40;
//TCCR0B=0x05;
//TCNT0=0xFF;
//OCR0A=0x00;
//OCR0B=0x00;
// OC0A output: Disconnected
// OC0B output: Disconnected
//+
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Timer1 Overflow Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
PLLCSR=0x00;

TCCR1=0x00;
GTCCR=0x00;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR0=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

//   .       
shiftAll();

// Global enable interrupts
#asm("sei")

srand(6636);
while (1)
  {
     if (takt==0) X = rand() % 8;// % 0xFF; 

     if ((takt<numled) && (X > 0)) { PORTB.1= 1; --X; }
     else PORTB.1= 0; 

     if (takt++ > pause) { takt = 0; cikl++; }
        
     if (cikl == ciklChange)
      {        
        cikl  = 0;    
        pause = pause + delta;
        if (pause == 0) delta = step;
        else
        if (pause==(maxled)) delta= -step;
      }
     //      CLOCK -> PORTB.0
     mkCLOCK();
//     delay = (mindelay+(8-takt / 8))*2;
     delay = (mindelay+(8-takt)/8)*2;
//     delay = mindelay+(maxled-(takt-numled)*2)/3;
     if (delay < mindelay) delay = mindelay;
     delay_ms(delay); 

  }
}
